
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>emulsion.agent.process &#8212; EMULSION (Epidemiological Multi-Level Simulation framework)</title>
    <link rel="stylesheet" href="../../../_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/css/custom.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <script async="async" type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.5/latest.js?config=TeX-AMS-MML_HTMLorMML"></script>
    <link rel="shortcut icon" href="../../../_static/STEMAH-favicon.png"/>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" />
   
  <link rel="stylesheet" href="../../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for emulsion.agent.process</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;A Python implementation of the EMuLSion framework (Epidemiologic</span>
<span class="sd">MUlti-Level SImulatiONs).</span>

<span class="sd">Classes and functions for process management in MultiProcessCompartments.</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="c1"># [HEADER]</span>


<span class="kn">from</span>   <span class="nn">abc</span>                       <span class="k">import</span> <span class="n">abstractmethod</span>
<span class="kn">import</span> <span class="nn">numpy</span>                     <span class="k">as</span> <span class="nn">np</span>

<span class="kn">from</span>   <span class="nn">emulsion.tools.misc</span>       <span class="k">import</span> <span class="n">rates_to_probabilities</span><span class="p">,</span> <span class="n">aggregate_probabilities</span><span class="p">,</span> <span class="n">count_population</span>

<div class="viewcode-block" id="AbstractProcess"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.AbstractProcess">[docs]</a><span class="k">class</span> <span class="nc">AbstractProcess</span><span class="p">(</span><span class="nb">object</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;An AbstractProcess is aimed at controlling a specific activity</span>
<span class="sd">    in a compartment, and is identified by its name.</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="AbstractProcess.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.AbstractProcess.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="n">name</span></div>

    <span class="k">def</span> <span class="nf">__repr__</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="s1">&#39;Process &quot;</span><span class="si">{}</span><span class="s1">&quot;&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">name</span><span class="p">)</span>

    <span class="fm">__str__</span> <span class="o">=</span> <span class="fm">__repr__</span>

<div class="viewcode-block" id="AbstractProcess.evolve"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.AbstractProcess.evolve">[docs]</a>    <span class="nd">@abstractmethod</span>
    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Define the actions that the process must perform.&quot;&quot;&quot;</span>
        <span class="k">pass</span></div></div>


<div class="viewcode-block" id="MethodProcess"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.MethodProcess">[docs]</a><span class="k">class</span> <span class="nc">MethodProcess</span><span class="p">(</span><span class="n">AbstractProcess</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;A MethodProcess is aimed at running a specific method (and</span>
<span class="sd">    possibly any function or even any callable object).</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="MethodProcess.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.MethodProcess.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">method</span><span class="p">,</span> <span class="n">lparams</span><span class="o">=</span><span class="p">[],</span> <span class="n">dparams</span><span class="o">=</span><span class="p">{}):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">method</span> <span class="o">=</span> <span class="n">method</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">lparams</span> <span class="o">=</span> <span class="n">lparams</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">dparams</span> <span class="o">=</span> <span class="n">dparams</span></div>

<div class="viewcode-block" id="MethodProcess.evolve"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.MethodProcess.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Define the actions that the process must perform. In a</span>
<span class="sd">        MethodProcess, those actions consist in running the method of</span>
<span class="sd">        the target compartment.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">method</span><span class="p">(</span><span class="o">*</span><span class="bp">self</span><span class="o">.</span><span class="n">lparams</span><span class="p">,</span> <span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">dparams</span><span class="p">)</span></div>

<div class="viewcode-block" id="MethodProcess.detach_model"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.MethodProcess.detach_model">[docs]</a>    <span class="k">def</span> <span class="nf">detach_model</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">pass</span></div></div>


<div class="viewcode-block" id="StateMachineProcess"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.StateMachineProcess">[docs]</a><span class="k">class</span> <span class="nc">StateMachineProcess</span><span class="p">(</span><span class="n">AbstractProcess</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;A StateMachineProcess is aimed at running a specific state machine</span>
<span class="sd">    within the agent (not within a grouping).</span>

<span class="sd">    &quot;&quot;&quot;</span>
<div class="viewcode-block" id="StateMachineProcess.__init__"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.StateMachineProcess.__init__">[docs]</a>    <span class="k">def</span> <span class="nf">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">,</span> <span class="n">agent</span><span class="p">,</span> <span class="n">state_machine</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">()</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">name</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">agent</span> <span class="o">=</span> <span class="n">agent</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span> <span class="o">=</span> <span class="n">state_machine</span></div>

<div class="viewcode-block" id="StateMachineProcess.evolve"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.StateMachineProcess.evolve">[docs]</a>    <span class="k">def</span> <span class="nf">evolve</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot;Define the actions that the process must perform. In a</span>
<span class="sd">        StateMachineProcess, those actions consist in 1) executing the</span>
<span class="sd">        transitions of the state machine to change the agent&#39;s states</span>
<span class="sd">        and 2) computing productions and transmit them to the upper</span>
<span class="sd">        level of the agent.</span>

<span class="sd">        &quot;&quot;&quot;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">evolve_transitions</span><span class="p">()</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">upper_level</span><span class="p">()</span><span class="o">.</span><span class="n">new_agents</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">evolve_productions</span><span class="p">()</span></div>

<div class="viewcode-block" id="StateMachineProcess.evolve_transitions"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.StateMachineProcess.evolve_transitions">[docs]</a>    <span class="k">def</span> <span class="nf">evolve_transitions</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># retrieve the name of the statevar/attribute where the</span>
        <span class="c1"># current state is stored</span>
        <span class="n">statevar</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span>
        <span class="c1"># retrieve the value of the current state</span>
        <span class="c1">#current_state = self.get_information(statevar).name</span>
        <span class="n">current_state</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">statevar</span><span class="p">]</span><span class="o">.</span><span class="n">name</span>
        <span class="c1"># perform actions associated to the current state</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_stay&#39;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="p">,</span>
                                    <span class="n">current_state</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
        <span class="c1"># retrieve all possible transitions from this state</span>
        <span class="n">transitions</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">next_states_from</span><span class="p">(</span><span class="n">current_state</span><span class="p">,</span>
                                                  <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="p">)</span>
        <span class="c1"># skip this machine if no available transitions</span>
        <span class="k">if</span> <span class="n">transitions</span><span class="p">:</span>
            <span class="n">states</span><span class="p">,</span> <span class="n">flux</span><span class="p">,</span> <span class="n">values</span><span class="p">,</span> <span class="n">_</span><span class="p">,</span> <span class="n">actions</span> <span class="o">=</span> <span class="nb">zip</span><span class="p">(</span><span class="o">*</span><span class="n">transitions</span><span class="p">)</span>
            <span class="n">total_value</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
            <span class="n">states</span> <span class="o">=</span> <span class="n">states</span> <span class="o">+</span> <span class="p">(</span><span class="n">current_state</span><span class="p">,)</span>
            <span class="n">actions</span> <span class="o">=</span> <span class="n">actions</span> <span class="o">+</span> <span class="p">([],</span> <span class="p">)</span>
            <span class="n">available_flux</span> <span class="o">=</span> <span class="nb">set</span><span class="p">(</span><span class="n">flux</span><span class="p">)</span>
            <span class="k">if</span> <span class="s1">&#39;amount&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span> <span class="ow">or</span> <span class="s1">&#39;amount-all-but&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span><span class="p">:</span>
            <span class="c1"># handle amounts</span>
                <span class="c1"># compute proper values (bounded by 0/1) and when</span>
                <span class="c1"># needed, invert &#39;amount-all-but&#39; values</span>
                <span class="n">values</span> <span class="o">=</span> <span class="p">[</span><span class="nb">max</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="mi">1</span><span class="o">-</span><span class="n">v</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span> <span class="mi">0</span><span class="p">)</span> <span class="k">if</span> <span class="n">f</span> <span class="o">==</span> <span class="s1">&#39;amount-all-but&#39;</span>\
                            <span class="k">else</span> <span class="nb">max</span><span class="p">(</span><span class="nb">min</span><span class="p">(</span><span class="n">v</span><span class="p">,</span> <span class="mi">1</span><span class="p">),</span> <span class="mi">0</span><span class="p">)</span>
                          <span class="k">for</span> <span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">v</span><span class="p">)</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span><span class="n">flux</span><span class="p">,</span> <span class="n">values</span><span class="p">)]</span>
                <span class="c1"># recompute total value</span>
                <span class="n">total_value</span> <span class="o">=</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">)</span>
                <span class="c1"># normalize to have probabilities</span>
                <span class="k">if</span> <span class="n">total_value</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">values</span> <span class="o">=</span> <span class="p">(</span><span class="mi">0</span><span class="p">,)</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="n">values</span><span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="mi">1</span><span class="p">,)</span>
                <span class="k">else</span><span class="p">:</span>
                    <span class="n">values</span> <span class="o">=</span> <span class="nb">tuple</span><span class="p">(</span><span class="n">v</span> <span class="o">/</span> <span class="n">total_value</span>
                                   <span class="k">for</span> <span class="n">v</span> <span class="ow">in</span> <span class="n">values</span><span class="p">)</span> <span class="o">+</span> <span class="p">(</span><span class="mi">1</span><span class="o">-</span> <span class="n">total_value</span><span class="p">,)</span>
            <span class="k">elif</span> <span class="s1">&#39;proba&#39;</span> <span class="ow">in</span> <span class="n">available_flux</span><span class="p">:</span>
                <span class="c1"># handle probabilities</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">aggregate_probabilities</span><span class="p">(</span><span class="n">values</span><span class="p">,</span>
                                                 <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
                <span class="n">values</span> <span class="o">+=</span> <span class="p">(</span><span class="mi">1</span> <span class="o">-</span> <span class="nb">sum</span><span class="p">(</span><span class="n">values</span><span class="p">),)</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="c1"># transform rates into probabilities</span>
                <span class="n">values</span> <span class="o">=</span> <span class="n">rates_to_probabilities</span><span class="p">(</span><span class="n">total_value</span><span class="p">,</span> <span class="n">values</span><span class="p">,</span>
                                                <span class="n">delta_t</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">model</span><span class="o">.</span><span class="n">delta_t</span><span class="p">)</span>
            <span class="n">index</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">nonzero</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">random</span><span class="o">.</span><span class="n">multinomial</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">values</span><span class="p">))[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">next_state</span> <span class="o">=</span> <span class="n">states</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
            <span class="n">next_action</span> <span class="o">=</span> <span class="n">actions</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
            <span class="c1"># condition on the index, so as to allow reflexive edges !</span>
            <span class="k">if</span> <span class="n">index</span> <span class="o">!=</span> <span class="nb">len</span><span class="p">(</span><span class="n">values</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">:</span>
            <span class="c1"># if next_state != current_state:</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_exit&#39;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="p">,</span>
                                            <span class="n">current_state</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
                <span class="c1"># self.agent.set_information(statevar,</span>
                <span class="c1">#                            self.state_machine.states[next_state])</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">change_state</span><span class="p">(</span><span class="n">statevar</span><span class="p">,</span>
                                        <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">states</span><span class="p">[</span><span class="n">next_state</span><span class="p">])</span>
                <span class="c1"># self.agent.do_edge_actions(&#39;on_cross&#39;, state_machine,</span>
                <span class="c1">#                      current_state, next_state, population=1)</span>
                <span class="k">if</span> <span class="n">next_action</span><span class="p">:</span>
                    <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">do_edge_actions</span><span class="p">(</span><span class="n">actions</span><span class="o">=</span><span class="n">next_action</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">do_state_actions</span><span class="p">(</span><span class="s1">&#39;on_enter&#39;</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="p">,</span>
                                            <span class="n">next_state</span><span class="p">,</span> <span class="n">population</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span></div>

<div class="viewcode-block" id="StateMachineProcess.evolve_productions"><a class="viewcode-back" href="../../../emulsion.agent.html#emulsion.agent.process.StateMachineProcess.evolve_productions">[docs]</a>    <span class="k">def</span> <span class="nf">evolve_productions</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1"># init empty list for all changes to perform</span>
        <span class="n">future</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="c1"># retrieve the name of the statevar/attribute where the</span>
        <span class="c1"># current state is stored</span>
        <span class="n">statevar</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="o">.</span><span class="n">machine_name</span>
        <span class="c1"># retrieve the value of the current state</span>
        <span class="n">current_state</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">statevars</span><span class="p">[</span><span class="n">statevar</span><span class="p">]</span><span class="o">.</span><span class="n">name</span>
        <span class="c1"># retrieve all possible productions from this state</span>
        <span class="n">productions</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">production_from</span><span class="p">(</span><span class="n">current_state</span><span class="p">,</span>
                                                 <span class="bp">self</span><span class="o">.</span><span class="n">state_machine</span><span class="p">)</span>
        <span class="c1"># skip this machine if no available transitions</span>
        <span class="k">if</span> <span class="n">productions</span><span class="p">:</span>
            <span class="c1">### HERE WE ASSUME THAT AN AGENT CAN PRODUCE SEVERAL OTHER</span>
            <span class="c1">### AGENTS SIMULTANEOUSLY (OTHERWISE USE CONDITIONS)</span>
            <span class="c1">### REWRITE TRANSITIONS TO HAVE DISJOINT SUB-POPULATIONS</span>
            <span class="k">for</span> <span class="n">target_state</span><span class="p">,</span> <span class="n">flux</span><span class="p">,</span> <span class="n">values</span><span class="p">,</span> <span class="n">ref_pop</span><span class="p">,</span> <span class="n">proto</span> <span class="ow">in</span> <span class="n">productions</span><span class="p">:</span>
                <span class="n">pop_size</span> <span class="o">=</span> <span class="n">count_population</span><span class="p">(</span><span class="n">ref_pop</span><span class="p">)</span>
                <span class="n">amount</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">_compute_production</span><span class="p">(</span><span class="n">values</span><span class="p">,</span> <span class="n">flux</span><span class="p">,</span> <span class="n">pop_size</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">agent</span><span class="o">.</span><span class="n">stochastic</span><span class="p">)</span>
                <span class="k">if</span> <span class="n">amount</span> <span class="o">&gt;</span> <span class="mi">0</span><span class="p">:</span>
                    <span class="n">future</span><span class="o">.</span><span class="n">append</span><span class="p">((</span><span class="n">target_state</span><span class="p">,</span> <span class="n">amount</span><span class="p">,</span> <span class="n">proto</span><span class="p">))</span>
        <span class="k">return</span> <span class="n">future</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../../index.html">EMULSION</a></h1>



<p class="blurb">Epidemiological Multi-Level Simulation Framework</p>






<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Information.html">1. Information</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Install.html">2. Installation</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Getting_started.html">3. Getting started with EMULSION</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_principles.html">4. Modelling principles</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_basics.html">5. Modelling language (basics)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Modelling_language_advanced.html">6. Modelling language (advanced)</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Feature_examples.html">7. Feature examples</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/Release_notes.html">8. Release notes</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../pages/License.html">9. License</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion_for_modellers.html">10. High-level functions for model designers</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../emulsion.html">11. emulsion package</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../../index.html">Documentation overview</a><ul>
  <li><a href="../../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2016, INRAE and Univ. Lille.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 1.8.5</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.10</a>
      
    </div>

    

    
  </body>
</html>